## nsis 3.05

=== SConstruct ===
EnsureSConsVersion(1,2)
EnsurePythonVersion(2,7)

stubs = [
	'bzip2',
	'lzma',
	'zlib'
]

plugin_libs = [
	'ExDLL'
]

plugins = [
	'AdvSplash',
	'Banner',
	'BgImage',
	'Dialer',
	'InstallOptions',
	'LangDLL',
	'Library/TypeLib',
	'Math',
	'nsDialogs',
	'nsExec',
	'NSISdl',
	'Splash',
	'StartMenu',
	'System',
	'UserInfo',
	'VPatch/Source/Plugin',
]

utils = [
	'Library/RegTool',
	'MakeLangId',
	'Makensisw',
	'NSIS Menu',
	'UIs',
	'SubStart',
	'VPatch/Source/GenPat',
	'zip2exe'
]

misc = [
	'Graphics',
	'Language files',
	'MultiUser',
	'Modern UI',
	'Modern UI 2',
	'VPatch'
]

doc = [
	'COPYING'
]

doctypes = [
	'chm',
	'html',
	'htmlsingle'
]

######################################################################
#######  Build Environment                                         ###
######################################################################

path = ARGUMENTS.get('PATH', '')
toolset = ARGUMENTS.get('TOOLSET', '')
arch = ARGUMENTS.get('TARGET_ARCH', 'x86')

if toolset and path:
	defenv = Environment(TARGET_ARCH = arch, ENV = {'PATH' : path}, TOOLS = toolset.split(',') + ['zip'])
else:
	if path:
		defenv = Environment(TARGET_ARCH = arch, ENV = {'PATH' : path})
	if toolset:
		defenv = Environment(TARGET_ARCH = arch, TOOLS = toolset.split(',') + ['zip'])
if not toolset and not path:
	defenv = Environment(TARGET_ARCH = arch)

Export('defenv')

######################################################################
#######  Includes                                                  ###
######################################################################

SConscript('SCons/utils.py')

######################################################################
#######  Options                                                   ###
######################################################################

import os
default_doctype = 'html'
if defenv.WhereIs('hhc', os.environ['PATH']):
	default_doctype = 'chm'

from time import strftime, gmtime
cvs_version = strftime('%d-%b-%Y.cvs', gmtime())

opts = Variables()

# load configuration options
#  it's important this will be done here so NSIS_CONFIG_CONST_DATA_PATH
#  will be available for the next few lines and so `dirs` can be set
SConscript('SCons/config.py')

opts.Update(defenv)
Help(opts.GenerateHelpText(defenv))

#Fix ListVariable to generate comma separated (quoted if required) list of allowed names:
org_ListVariable = ListVariable
def ListVariable(key, help, default, names, map={}):
	r = list(org_ListVariable(key, help, default, names, map))
	if len(r) == 5 and isinstance(r[1], str):
		fmt = 'allowed names: %s'
		repl = fmt % ', '.join( ((' ' in s) and ('"%s"' % s) or s) for s in names )
		r[1] = r[1].replace(fmt % ' '.join(names), repl)
	return r


install_dirs = {
	'relocatable': {
		'dest': '',
		'prefix': '',
		'conf': '$PREFIX',
		'bin': '$PREFIX',
		'data': '$PREFIX',
		'doc': '$PREFIX'
	},
	'static': {
		'dest': '',
		'prefix': '/usr/local',
		'conf': '$PREFIX/etc',
		'bin': '$PREFIX/bin',
		'data': '$PREFIX/share/nsis',
		'doc': '$PREFIX/share/doc/nsis'
	}
}

if 'NSIS_CONFIG_CONST_DATA_PATH' in defenv['NSIS_CPPDEFINES']:
	dirs = install_dirs['static']
else:
	dirs = install_dirs['relocatable']

if defenv['PLATFORM'] == 'win32':
	ignore_tests = 'none'
else:
	ignore_tests = ','.join(Split("""
Examples/makensis.nsi"""))

# version
opts.Add(('VERSION', 'Version of NSIS', cvs_version))
opts.Add(('VER_MAJOR', 'Major version of NSIS (recommended for dist-installer)', None))
opts.Add(('VER_MINOR', 'Minor version of NSIS (recommended for dist-installer)', None))
opts.Add(('VER_REVISION', 'Revision of NSIS', None))
opts.Add(('VER_BUILD', 'Build version of NSIS', None))
opts.Add(('VER_PACKED', 'Packed version of NSIS in 0xMMmmmrrb format, used for feature detection in scripts (recommended if VER_MAJOR and VER_MINOR are not set)', None))
# installation
opts.Add(('PREFIX', 'Installation prefix', dirs['prefix']))
opts.Add(ListVariable('SKIPSTUBS', 'A list of stubs that will not be built', 'none', stubs))
opts.Add(ListVariable('SKIPPLUGINS', 'A list of plug-ins that will not be built', 'none', plugin_libs + plugins))
opts.Add(ListVariable('SKIPUTILS', 'A list of utilities that will not be built', 'NSIS Menu', utils))
opts.Add(ListVariable('SKIPMISC', 'A list of plug-ins that will not be built', 'none', misc))
opts.Add(ListVariable('SKIPDOC', 'A list of doc files that will not be built/installed', 'none', doc))
opts.Add(('SKIPTESTS', 'A comma-separated list of test files that will not be ran', 'none'))
opts.Add(('IGNORETESTS', 'A comma-separated list of test files that will be ran but ignored', ignore_tests))
# build tools
opts.Add(('PATH', 'A colon-separated list of system paths instead of the default - TEMPORARY AND MAY DEPRECATE', None))
opts.Add(('TOOLSET', 'A comma-separated list of specific tools used for building instead of the default', None))
opts.Add(BoolVariable('MSTOOLKIT', 'Use Microsoft Visual C++ Toolkit', 'no'))
opts.Add(EnumVariable('MSVS_VERSION', 'MS Visual C++ version', os.environ.get('MSVS_VERSION'), allowed_values=('6.0', '7.0', '7.1', '8.0', '8.0Exp', '9.0', '9.0Exp', '10.0', '10.0Exp')))
opts.Add(EnumVariable('TARGET_ARCH', 'Target processor architecture', 'x86', allowed_values=('x86', 'amd64', 'arm64')))
opts.Add(ListVariable('DOCTYPES', 'A list of document types that will be built', default_doctype, doctypes))
opts.Add(('CC', 'Override C compiler', None))
opts.Add(('CXX', 'Override C++ compiler', None))
opts.Add(PathVariable('APPEND_CPPPATH', 'Additional paths to search for include files', None))
opts.Add(PathVariable('APPEND_LIBPATH', 'Additional paths to search for libraries', None))
opts.Add(('APPEND_CCFLAGS', 'Additional C/C++ compiler flags'))
opts.Add(('APPEND_LINKFLAGS', 'Additional linker flags'))
opts.Add(PathVariable('WXWIN', 'Path to wxWindows library folder (e.g. C:\\Dev\\wxWidgets-2.8.10)', os.environ.get('WXWIN')))
opts.Add(PathVariable('ZLIB_W32', 'Path to Win32 zlib library folder (e.g. C:\\Dev\\zlib-1.2.3)', os.environ.get('ZLIB_W32')))
# build options
opts.Add(BoolVariable('UNICODE', 'Build the Unicode version of the compiler and tools', 'yes'))
opts.Add(BoolVariable('DEBUG', 'Build executables with debugging information', 'no'))
opts.Add(PathVariable('CODESIGNER', 'A program used to sign executables', None))
opts.Add(BoolVariable('STRIP', 'Strips executables of any unrequired data such as symbols', 'yes'))
opts.Add(BoolVariable('STRIP_CP', 'Strips cross-platform executables of any unrequired data such as symbols', 'yes'))
opts.Add(BoolVariable('STRIP_W32', 'Strips Win32 executables of any unrequired data such as symbols', 'yes'))
# path related build options
opts.Add(('PREFIX_DEST', 'Intermediate installation prefix (extra install time prefix)', dirs['dest']))
opts.Add(('PREFIX_CONF', 'Path to install nsisconf.nsh to', dirs['conf']))
opts.Add(('PREFIX_BIN', 'Path to install native binaries to', dirs['bin']))
opts.Add(('PREFIX_DATA', 'Path to install nsis data to (plugins, includes, stubs, contrib, win32 binaries)', dirs['data']))
opts.Add(('PREFIX_DOC','Path to install nsis README / INSTALL / TODO files to.', dirs['doc']))
opts.Add(('PREFIX_PLUGINAPI_INC','Path to install plugin API headers to.', None))
opts.Add(('PREFIX_PLUGINAPI_LIB','Path to install plugin static library to.', None))

opts.Update(defenv)
Help(opts.GenerateHelpText(defenv))

if defenv['TARGET_ARCH'] != 'x86':
	defenv['UNICODE'] = True

if defenv['DEBUG']:
	defenv.Append(CPPDEFINES = ['DEBUG'])

# add prefixes defines
if 'NSIS_CONFIG_CONST_DATA_PATH' in defenv['NSIS_CPPDEFINES']:
	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_CONF', '"%s"' % defenv.subst('$PREFIX_CONF'))])
	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_DATA', '"%s"' % defenv.subst('$PREFIX_DATA'))])
	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_DOC', '"%s"' % defenv.subst('$PREFIX_DOC'))])

# Need this early for the config header files to be placed in
if defenv['UNICODE']:
	if defenv['DEBUG']:
		defenv.Replace(BUILD_PREFIX = 'build/udebug')
	else:
		defenv.Replace(BUILD_PREFIX = 'build/urelease')
else:
	if defenv['DEBUG']:
		defenv.Replace(BUILD_PREFIX = 'build/debug')
	else:
		defenv.Replace(BUILD_PREFIX = 'build/release')

defenv.Replace(BUILD_CONFIG = defenv.subst('$BUILD_PREFIX/config'))

# ensure the config directory exists
if not Dir(defenv.Dir('#$BUILD_CONFIG')).exists():
	defenv.Execute(Mkdir(defenv.Dir('#$BUILD_CONFIG')))

# write configuration into sconf.h and defines.h
sconf_h = open(defenv.File('#$BUILD_CONFIG/nsis-sconf.h').abspath, 'w')
sconf_h.write('// This file is automatically generated by SCons\n// DO NOT EDIT THIS FILE\n')

defines_h = open(defenv.File('#$BUILD_CONFIG/nsis-defines.h').abspath, 'w')
defines_h.write('// This file is automatically generated by SCons\n// DO NOT EDIT THIS FILE\n')

for i in defenv['NSIS_CPPDEFINES']:
	if type(i) is not str:
		sconf_h.write('#define %s %s\n' % (i[0], i[1]))
		if str(i[1])[0] != '"':
			defines_h.write('definedlist.add(_T("%s"), _T("%s"));\n' % (i[0], i[1]))
		else:
			defines_h.write('definedlist.add(_T("%s"), _T(%s));\n' % (i[0], i[1]))
	else:
		sconf_h.write('#define %s\n' % (i))
		defines_h.write('definedlist.add(_T("%s"));\n' % (i))
sconf_h.close()
defines_h.close()

# write version into version.h
f = open(defenv.File('#$BUILD_CONFIG/nsis-version.h').abspath, 'w')
f.write('// This file is automatically generated by SCons\n// DO NOT EDIT THIS FILE\n')
f.write('#include "%s"\n' % File('#/Source/tchar.h').abspath)

if (not 'VER_PACKED' in defenv) and 'VER_MAJOR' in defenv and 'VER_MINOR' in defenv:
	packed_r = int(defenv.get('VER_REVISION','0'))
	packed_b = int(defenv.get('VER_BUILD','0'))
	defenv['VER_PACKED'] = '0x%0.2i%0.3i%0.2i%0.1i' % (int(defenv['VER_MAJOR']), int(defenv['VER_MINOR']), packed_r, packed_b)
if not 'VER_PACKED' in defenv:
	import re
	found = None
	for v in re.compile(r'^\\H\{[v]?(\S+)\}', re.M).finditer(File('#/Docs/src/history.but').get_contents().decode()): # Try to parse the Halibut history file
		if v and not found:
			v = v.group(1).split('.')
			if len(v) >= 2:
				mi = int(re.search(r'\d+', v[1]).group())
				if mi < 1: mi = 1 # Make sure we can subtract 1 from the minor number so trunk stays below the next release
				defenv['VER_PACKED'] = '0x%0.2i%0.3i%0.2i%0.1i' % (int(re.search(r'\d+', v[0]).group()), mi - 1, 66, 6)
				if int(defenv['VER_PACKED'], 0) >= int('0x03000000', 0):
					found = v
	if not found:
		defenv['VER_PACKED'] = '0x%0.2i%0.3i%0.2i%0.1i' % (3, 3, 42, 0) # Default to a version number we never used
	print('WARNING: VER_PACKED not set, defaulting to %s!' % defenv['VER_PACKED'])
if int(defenv['VER_PACKED'], 0) < int('0x03000000', 0) or int(defenv['VER_PACKED'], 0) >= int('0x04000000', 0):
	print('ERROR: Invalid VER_PACKED value!')
	Exit(1)
f.write('#define NSIS_PACKEDVERSION _T("%s")\n' % defenv['VER_PACKED'])

if 'VER_MAJOR' in defenv and defenv.get('VERSION','') == '':
	defenv['VERSION'] = defenv['VER_MAJOR']
	if 'VER_MINOR' in defenv:
		defenv['VERSION'] += '.' + defenv['VER_MINOR']
	if 'VER_REVISION' in defenv:
		defenv['VERSION'] += '.' + defenv['VER_REVISION']
f.write('#define NSIS_VERSION _T("v%s")\n' % defenv['VERSION'])

f.close()

######################################################################
#######  Common Functions                                          ###
######################################################################

def GetArcCPU(env):
	if (not 'TARGET_ARCH' in env) or env['TARGET_ARCH'] == 'x86':
		return 'x86'
	return env['TARGET_ARCH']

def GetArcSuffix(env, unicode = None):
	if unicode is None:
		unicode = 'UNICODE' in env['CPPDEFINES']
	suff = '-unicode'
	if not unicode:
		suff = '-ansi'
	return GetArcCPU(env) + suff

def SafeFile(f):
	from types import StringType

	if isinstance(f, StringType):
		return File(f)

	return f

def MakeFileList(files):
	return Flatten(File(files))

def AddEnvStandardFlags(env, defines=None, flags=None, libs=None, entry=None, nodeflib=None):
	if defines:

=== debian/changelog ===
nsis (3.05-2) unstable; urgency=medium

  [ Thomas Gaugler ]
  * d/control: Switch to secure (HTTPS) homepage
  * d/control: Set Rules-Requires-Root to no
  * Consistent use of flags in test and install targets
  * Remove build directory instead of clean up via Scons
  * Reduce build scope by skipping plugins and stubs for host tools
  * Removal of LibraryLocal man page
  * Propagate CCACHE_DIR and SOURCE_DATE_EPOCH environment variables to
    SCons build system for ccache and reproducible builds
  * Python 3 fixes
  * Split suffixes prepended with + or ~ from version
  * Remove __pycache__ directory during clean

  [ Didier Raboud ]
  * Add Salsa CI pipeline config
  * Bump Standards-Version to 4.5 without changes needed
  * Discard .pyc files after clean (Closes: #952269)

 -- Thomas Gaugler <thomas@dadie.net>  Tue, 31 Mar 2020 20:05:25 +0200

nsis (3.05-1) unstable; urgency=medium

  [ Thomas Gaugler ]
  * New 3.05 upstream release (Closes: #947572)
  * Retain SEH flag also for resulting installer
  * Adapted line offsets of patches for NSIS 3.05

  [ Didier Raboud ]
  * Refresh d/copyright by merging all contributors and dates, per license;
    add the missing wxWindows license
  * Update standards version to 4.4.1, no changes needed.

 -- Didier Raboud <odyx@debian.org>  Wed, 15 Jan 2020 09:42:48 +0100

nsis (3.04-2) unstable; urgency=medium

  [ Thomas Gaugler ]
  * Keep Structured Exception Handling (SEH) flag
  * Add debian/upstream/metadata file
  * Test package in its installed state
  * d/copyright: Fix matching of paths containing a space
  * Replace extracting version from changelog with DEB_VERSION
  * d/changelog: Remove empty line at the end of the file
  * Missing signature of tarball: Overrule lintian warning
  * Makensisw, NSIS Menu, zip2exe: overrule lintian warnings
  * Fix unaligned memory accesses (Closes: #918376)
  * Propagate SOURCE_DATE_EPOCH environment variable

  [ Didier Raboud ]
  * Update standards version to 4.4.0, no changes needed.
  * Bump debhelper from old 11 to 12.

 -- Thomas Gaugler <thomas@dadie.net>  Fri, 23 Aug 2019 15:07:51 +0200

=== debian/control ===
Source: nsis
Maintainer: Thomas Gaugler <thomas@dadie.net>
Uploaders: Didier Raboud <odyx@debian.org>
Section: devel
Priority: optional
Build-Depends: docbook-xsl-ns,
               docbook5-xml,
               dpkg-dev (>= 1.17.0),
               html2text,
               libcppunit-dev,
               mingw-w64,
               scons,
               xsltproc,
               zlib1g-dev,
               debhelper-compat (= 12)
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/nsis
Vcs-Git: https://salsa.debian.org/debian/nsis.git
Homepage: https://nsis.sourceforge.io/

Package: nsis
Architecture: any
Depends: nsis-common (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: mingw-w64,
          nsis-doc (>= ${source:Version}),
          nsis-pluginapi (>= ${source:Version}),
          wine [amd64 i386 kfreebsd-amd64 kfreebsd-i386 powerpc]
Description: Nullsoft Scriptable Install System (modified for Debian)
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 NSIS creates installers that are capable of installing, uninstalling,
 setting system settings, extracting files, etc. Because it's based on
 script files, you can fully control every part of your installers. The
 script language supports variables, functions, string manipulation,
 just like a normal programming language - but designed for the creation
 of installers. Even with all these features, NSIS is still the smallest
 installer system available. With the default options, it has an overhead
 of only 34 KB.

Package: nsis-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Nullsoft Scriptable Install System stubs and plugins
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains the stubs and plugins of NSIS.

Package: nsis-pluginapi
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: mingw-w64
Enhances: nsis (>= ${source:Version})
Description: Nullsoft Scriptable Install System plugin API
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains the header and library files for developing
 NSIS plugins.

Package: nsis-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Nullsoft Scriptable Install System documentation
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains examples and the documentation in HTML format.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Exclude .svn directories from packages
export DH_ALWAYS_EXCLUDE=.svn

# Enable hardening
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

VERSION=$(DEB_VERSION)
PREFIX=/usr
DATADIR=$(PREFIX)/share/nsis
DOCDIR=$(PREFIX)/share/doc/nsis
SYSCONF=/etc
BUILDDIR=build
UNICODE=yes
TESTDIR=$(CURDIR)/$(BUILDDIR)/test

# Decomposition of version string
define SPLIT
	$(if $(2),$(call SPLIT,$(subst $(firstword $(2)), ,$(1)),$(filter-out $(firstword $(2)), $(2))), $(1))
endef
VERSION_DECOMPOSED=$(call SPLIT,$(VERSION),. - + ~)
VER_MAJOR=$(firstword $(VERSION_DECOMPOSED))
VER_MINOR=$(word 2,$(VERSION_DECOMPOSED))
VER_REVISION=$(word 3,$(VERSION_DECOMPOSED))

# Variables for Win32/Win64 cross compiler
XGCC_W32_X86 = i686-w64-mingw32-gcc
XGCC_W32_X86_PATH = $(abspath $(shell $(XGCC_W32_X86) -print-file-name=libkernel32.a)/../..)
XGCC_W32_X86_PREFIX = $(subst -gcc,-,$(XGCC_W32_X86))
XGCC_W32_AMD64 = x86_64-w64-mingw32-gcc
XGCC_W32_AMD64_PATH = $(abspath $(shell $(XGCC_W32_AMD64) -print-file-name=libkernel32.a)/../..)
XGCC_W32_AMD64_PREFIX = $(subst -gcc,-,$(XGCC_W32_AMD64))


# Evaluate parallel build option
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq (,$(shell dh_listpackages -i))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	SCONSFLAGS = -j $(NUMJOBS)
endif
endif

# Honor hardening flags
SCONSHOSTFLAGS = APPEND_CCFLAGS="$(shell dpkg-buildflags --get CPPFLAGS) \
  $(shell dpkg-buildflags --get CFLAGS)" \
  APPEND_LINKFLAGS="$(shell dpkg-buildflags --get LDFLAGS)"

SCONSOPTS = $(SCONSFLAGS) VERSION=$(VERSION) VER_MAJOR=$(VER_MAJOR) \
  VER_MINOR=$(VER_MINOR) VER_REVISION=$(VER_REVISION) \
  PREFIX=$(PREFIX) PREFIX_CONF=$(SYSCONF) CHMDOCS=0 \
  STRIP_CP=no \
  $(if $(findstring nostripfull,$(DEB_BUILD_OPTIONS)),STRIP_W32=no,)

ifneq (,$(UNICODE),yes)
	SCONSOPTS += UNICODE=yes
	BUILDTYPE := u
endif

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	SCONSOPTS += DEBUG=yes
	BUILDTYPE := $(BUILDTYPE)debug
else
	BUILDTYPE := $(BUILDTYPE)release
endif

ifdef XGCC_W32_X86_PATH
SCONSOPTS_X86 = PREFIX_PLUGINAPI_INC=$(XGCC_W32_X86_PATH)/include/ \
  PREFIX_PLUGINAPI_LIB=$(XGCC_W32_X86_PATH)/lib/ \
  XGCC_W32_PREFIX=$(XGCC_W32_X86_PREFIX) \
  TARGET_ARCH=x86
endif

ifdef XGCC_W32_AMD64_PATH
SCONSOPTS_AMD64 = PREFIX_PLUGINAPI_INC=$(XGCC_W32_AMD64_PATH)/include/ \
  PREFIX_PLUGINAPI_LIB=$(XGCC_W32_AMD64_PATH)/lib/ \
  XGCC_W32_PREFIX=$(XGCC_W32_AMD64_PREFIX) \
  TARGET_ARCH=amd64
endif

COMMA := ,

UTILS_ALL = 'Library/RegTool,MakeLangId,Makensisw,NSIS Menu,UIs,SubStart,VPatch/Source/GenPat,zip2exe'

# Only build GenPat for the host system
IGNORE_UTILS_NSIS   := $(subst $(COMMA)VPatch/Source/GenPat,,$(UTILS_ALL))

# Build the win32 user interfaces (UIs) and RegTool
IGNORE_UTILS_COMMON := $(subst Library/RegTool,,$(UTILS_ALL))
IGNORE_UTILS_COMMON := $(subst $(COMMA)UIs,,$(IGNORE_UTILS_COMMON))

SCONSOPTS_HOST   := $(SCONSHOSTFLAGS) $(SCONSOPTS) \
  SKIPPLUGINS=all SKIPSTUBS=all \
  SKIPUTILS=$(IGNORE_UTILS_NSIS) SKIPDOC=COPYING
SCONSOPTS_COMMON := $(SCONSOPTS) SKIPUTILS=$(IGNORE_UTILS_COMMON) \
  SKIPDOC=COPYING

INSTALL_nsis = install-utils install-compiler install-conf
INSTALL_FLAGS_nsis = $(SCONSOPTS_HOST)
INSTALL_nsis-common = install-stubs install-plugins install-data install-utils
INSTALL_FLAGS_nsis-common = $(SCONSOPTS_COMMON)
INSTALL_nsis-pluginapi = install-pluginapi
INSTALL_FLAGS_nsis-pluginapi = $(SCONSOPTS_COMMON)
INSTALL_nsis-doc = install-examples install-doc install-docs
INSTALL_FLAGS_nsis-doc = $(SCONSHOSTFLAGS) $(SCONSOPTS) \
  SKIPUTILS=$(IGNORE_UTILS_COMMON) SKIPDOC=COPYING

# Exclude test scripts which are not appropriate for POSIX platforms.
IGNORE_TESTS = makensis.nsi|gfx.nsi

# Path to .nsi scripts
SCRIPTS_PATH = $(DOCDIR)/Examples

define DO_SCONS_INSTALL
	scons $(INSTALL_FLAGS_$(1)) $(2) PREFIX_DEST="$(CURDIR)/debian/$(1)" $(INSTALL_$(1)) || exit 1;
endef

# Substitute reference to License text file in Modern UI examples
# with source file to enable their compilation with makensis
define SANITIZE_MODERN_UI
	for f in $$(find "$(1)" -type f -name '*.nsi' -print0 | xargs -0 -n 1 basename); \
	do \
		sed -i \
		-e "s&\$${NSISDIR}\\\\Docs\\\\Modern UI\\\\License.txt&$${f}&g" \
		"$(1)/$${f}"; \
	done
endef

# Replace duplicate files with symbolic link
define SYMLINK_DUPLICATES
	for f in $$(ls -1 "$(1)"); \
	do \
		cmp -s "$(1)/$${f}" "$(2)/$${f}"; \
		if [ $$? -eq 0 ]; \
		then \
			ln -sf "$(3)/$${f}" "$(2)/$${f}"; \
			echo $${f}; \
		fi; \
	done
endef

%:
	dh "$@"

override_dh_auto_clean:
	# Remove build directory instead of removing target files
	# via Scons due to pull in of dependencies.
	-rm -rf .sconf_temp .sconsign.dblite SCons/Tools/__pycache__ SCons/Tools/crossmingw.pyc build config.log .test $(BUILDDIR) $(TESTDIR)
	-rm -f Source/exehead/sconf.h Source/version.h Source/defines.h config.log

$(BUILDDIR)/NEWS:
	scons $(SCONSOPTS_HOST) Docs/src; \
	html2text -nobs "$(BUILDDIR)/$(BUILDTYPE)/Docs/html/AppendixF.html" | \
	sed -e '0,/^\*\*\*\*\*/c\NSIS Release Notes (automatically converted from AppendixF.html)' -e 's/F\.[.0-9]* //g' -e 's/^\*\*\*\** *\([^*]*\)  *\**\*\*\*/\n\1\n/g' -e '/Changelog/d' -e '/^NSIS_1.x_version_history/,/^=/c\    http://nsis.sourceforge.net/download/nsis1/' -e 's/^\(Released.*\)/    \1\n/g' | cat -s > "$@"

# Convert DocBook to man page
$(BUILDDIR)/%.1: debian/%.xml
	xsltproc --nonet --output $@ $<

override_dh_auto_build-arch: $(BUILDDIR)/NEWS $(BUILDDIR)/GenPat.1 $(BUILDDIR)/makensis.1
	scons $(SCONSOPTS_HOST) utils makensis

override_dh_auto_build-indep: $(BUILDDIR)/NEWS
	# nsis-common must be built on little-endian
	[ "$(shell dpkg-architecture -qDEB_BUILD_ARCH_ENDIAN)" = "little" ]
	
	scons $(SCONSOPTS_HOST) makensis
ifdef XGCC_W32_X86_PATH
	scons $(SCONSOPTS_COMMON) $(SCONSOPTS_X86) stubs plugins utils
endif
ifdef XGCC_W32_AMD64_PATH
	scons $(SCONSOPTS_COMMON) $(SCONSOPTS_AMD64) stubs plugins utils
endif
	html2text -style pretty -nobs -o "$(BUILDDIR)/README.Modern UI" "Contrib/Modern UI/Readme.html"
	html2text -style pretty -nobs -o "$(BUILDDIR)/README.Modern UI 2" "Contrib/Modern UI 2/Readme.html"
	html2text -style pretty -nobs -o $(BUILDDIR)/README.VPatch Contrib/VPatch/Readme.html
	html2text -style pretty -nobs -o $(BUILDDIR)/README.InstallOptions Contrib/InstallOptions/Readme.html
	html2text -style pretty -nobs -o $(BUILDDIR)/README.MultiUser Contrib/MultiUser/Readme.html
	html2text -style pretty -nobs -o $(BUILDDIR)/README.nsDialogs Contrib/nsDialogs/Readme.html

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	scons $(SCONSOPTS_HOST) test-code
endif

override_dh_auto_test-indep:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	test -x "$(BUILDDIR)/$(BUILDTYPE)/makensis/makensis" && \
	scons $(INSTALL_FLAGS_nsis) PREFIX_DEST="$(TESTDIR)"\
		install-compiler install-conf && \
	scons $(INSTALL_FLAGS_nsis-doc) PREFIX_DEST="$(TESTDIR)"\
		install-examples && \
	scons $(INSTALL_FLAGS_nsis-common) $(SCONSOPTS_X86) PREFIX_DEST="$(TESTDIR)" \
		$(INSTALL_nsis-common) && \
	scons $(INSTALL_FLAGS_nsis-common) $(SCONSOPTS_AMD64) PREFIX_DEST="$(TESTDIR)" \
		$(INSTALL_nsis-common) && \
	$(call SANITIZE_MODERN_UI,$(TESTDIR)$(DOCDIR)/Examples/Modern UI) && \
	for script_path in $(TESTDIR)$(SCRIPTS_PATH)/*.nsi \
		$(TESTDIR)$(SCRIPTS_PATH)/*/*.nsi; do \
		script=$${script_path#$(TESTDIR)$(SCRIPTS_PATH)/}; \
		if [ "$${script%/*}" != "$${script}" ]; then \
			mkdir -p "$(TESTDIR)/$${script%/*}"; \
		fi; \
		case $${script} in \
		$(IGNORE_TESTS)) ;; \
		*) \
		if [ -f "$${script_path}" ]; then \
			PATH=$(TESTDIR)$(PREFIX)/bin:$(PATH) \
			NSISDIR=$(TESTDIR)$(DATADIR) \
			NSISCONFDIR=$(TESTDIR)$(SYSCONF) \
			"$(TESTDIR)$(PREFIX)/bin/makensis" \
			"$${script_path}" \
			-X"OutFile \"$(TESTDIR)/$${script%.nsi}.exe\"" \
			|| exit 1; \
		fi;; \
		esac; \
	done;
	# Fail the build if libwinpthread is needed at runtime (see #722898)

=== debian/watch ===
version=3
https://sf.net/nsis/nsis-([\d.]*)-src.tar.bz2 debian uupdate

## nsis 3.06.1

=== SConstruct ===
--- 
+++ 
@@ -64,20 +64,20 @@
 #######  Build Environment                                         ###
 ######################################################################
 
+import os
 path = ARGUMENTS.get('PATH', '')
 toolset = ARGUMENTS.get('TOOLSET', '')
-arch = ARGUMENTS.get('TARGET_ARCH', 'x86')
-
-if toolset and path:
-	defenv = Environment(TARGET_ARCH = arch, ENV = {'PATH' : path}, TOOLS = toolset.split(',') + ['zip'])
-else:
-	if path:
-		defenv = Environment(TARGET_ARCH = arch, ENV = {'PATH' : path})
-	if toolset:
-		defenv = Environment(TARGET_ARCH = arch, TOOLS = toolset.split(',') + ['zip'])
-if not toolset and not path:
-	defenv = Environment(TARGET_ARCH = arch)
-
+
+defenv = {
+	'TARGET_ARCH': ARGUMENTS.get('TARGET_ARCH', 'x86'),
+	'ENV': {}
+}
+
+if path: defenv['ENV']['PATH'] = path
+if toolset: defenv['TOOLS'] = toolset.split(',') + ['zip']
+
+if len(defenv['ENV']) == 0: del defenv['ENV']
+defenv = Environment(**defenv)
 Export('defenv')
 
 ######################################################################
@@ -85,12 +85,12 @@
 ######################################################################
 
 SConscript('SCons/utils.py')
+Import('GetOptionOrEnv')
 
 ######################################################################
 #######  Options                                                   ###
 ######################################################################
 
-import os
 default_doctype = 'html'
 if defenv.WhereIs('hhc', os.environ['PATH']):
 	default_doctype = 'chm'
@@ -195,6 +195,8 @@
 opts.Add(('PREFIX_DOC','Path to install nsis README / INSTALL / TODO files to.', dirs['doc']))
 opts.Add(('PREFIX_PLUGINAPI_INC','Path to install plugin API headers to.', None))
 opts.Add(('PREFIX_PLUGINAPI_LIB','Path to install plugin static library to.', None))
+# reproducible builds
+opts.Add(('SOURCE_DATE_EPOCH', 'UNIX timestamp (in seconds)', os.environ.get('SOURCE_DATE_EPOCH')))
 
 opts.Update(defenv)
 Help(opts.GenerateHelpText(defenv))
@@ -210,6 +212,10 @@
 	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_CONF', '"%s"' % defenv.subst('$PREFIX_CONF'))])
 	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_DATA', '"%s"' % defenv.subst('$PREFIX_DATA'))])
 	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_DOC', '"%s"' % defenv.subst('$PREFIX_DOC'))])
+
+if defenv.get('SOURCE_DATE_EPOCH','') is not '':
+	defenv['ENV']['SOURCE_DATE_EPOCH'] = defenv['SOURCE_DATE_EPOCH'] = int(defenv['SOURCE_DATE_EPOCH'], 0) # Normalize and apply to ENV for child processes
+	defenv.Append(NSIS_CPPDEFINES = [('NSIS_SOURCE_DATE_EPOCH', '%s' % defenv['SOURCE_DATE_EPOCH'])]) # Display in /HDRINFO
 
 # Need this early for the config header files to be placed in
 if defenv['UNICODE']:
@@ -278,12 +284,15 @@
 	Exit(1)
 f.write('#define NSIS_PACKEDVERSION _T("%s")\n' % defenv['VER_PACKED'])
 
-if 'VER_MAJOR' in defenv and defenv.get('VERSION','') == '':
+if defenv.get('VERSION','') == '' and 'VER_MAJOR' in defenv:
 	defenv['VERSION'] = defenv['VER_MAJOR']
 	if 'VER_MINOR' in defenv:
 		defenv['VERSION'] += '.' + defenv['VER_MINOR']
 	if 'VER_REVISION' in defenv:
 		defenv['VERSION'] += '.' + defenv['VER_REVISION']
+if defenv.get('VERSION','') == '' and int(defenv['VER_PACKED'], 0) > int('0x02000000', 0):
+	defenv['VERSION'] = '%i.%i.%i' % (int(defenv['VER_PACKED'][2:][:2]), int(defenv['VER_PACKED'][4:][:3]), int(defenv['VER_PACKED'][7:][:2]))
+	print('WARNING: VERSION not set, defaulting to %s!' % defenv['VERSION'])
 f.write('#define NSIS_VERSION _T("v%s")\n' % defenv['VERSION'])
 
 f.close()
@@ -292,29 +301,3 @@
 #######  Common Functions                                          ###
 ######################################################################
 
-def GetArcCPU(env):
-	if (not 'TARGET_ARCH' in env) or env['TARGET_ARCH'] == 'x86':
-		return 'x86'
-	return env['TARGET_ARCH']
-
-def GetArcSuffix(env, unicode = None):
-	if unicode is None:
-		unicode = 'UNICODE' in env['CPPDEFINES']
-	suff = '-unicode'
-	if not unicode:
-		suff = '-ansi'
-	return GetArcCPU(env) + suff
-
-def SafeFile(f):
-	from types import StringType
-
-	if isinstance(f, StringType):
-		return File(f)
-
-	return f
-
-def MakeFileList(files):
-	return Flatten(File(files))
-
-def AddEnvStandardFlags(env, defines=None, flags=None, libs=None, entry=None, nodeflib=None):
-	if defines:

=== debian/changelog ===
nsis (3.06.1-1) unstable; urgency=medium

  * New upstream version 3.06.1
  * Adapted patches for version '3.06.1'
  * Python equality vs identity fix within scons scripts
  * Set CCACHE_DIR after initialization of default environment
  * Exclude POSIX incompatible install-(per-user|shared) test scripts
  * Increase to debhelper compatibility level 13
  * Plugin/nsis: override repeated-path-segment lintian warning
  * Mark SEH patch as not needed for upstream

 -- Thomas Gaugler <thomas@dadie.net>  Sat, 29 Aug 2020 21:32:12 +0200

nsis (3.05-4) unstable; urgency=medium

  [ Thomas Gaugler ]
  * Define halibut version string as external variable
    GCC 10 uses -fno-common by default and as a result the global version
    variable of halibut was considered to be defined multiple times.
    (Closes: #966870)

 -- Didier Raboud <odyx@debian.org>  Thu, 06 Aug 2020 17:33:42 +0200

nsis (3.05-3) unstable; urgency=medium

  [ Thomas Gaugler ]
  * Skip blhc job in Salsa CI pipeline

  [ Didier Raboud ]
  * Backport 'Don't let GCC 10 generate memmove calls (bug #1248)'
    upstream patch (Closes: #963282)

 -- Didier Raboud <odyx@debian.org>  Fri, 03 Jul 2020 16:06:02 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                scons,
                xsltproc,
                zlib1g-dev,
-               debhelper-compat (= 12)
+               debhelper-compat (= 13)
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/nsis

=== debian/rules ===
--- 
+++ 
@@ -110,7 +110,7 @@
   SKIPUTILS=$(IGNORE_UTILS_COMMON) SKIPDOC=COPYING
 
 # Exclude test scripts which are not appropriate for POSIX platforms.
-IGNORE_TESTS = makensis.nsi|gfx.nsi
+IGNORE_TESTS = gfx.nsi|install-per-user.nsi|install-shared.nsi|makensis.nsi
 
 # Path to .nsi scripts
 SCRIPTS_PATH = $(DOCDIR)/Examples
@@ -219,4 +219,3 @@
 		fi;; \
 		esac; \
 	done;
-	# Fail the build if libwinpthread is needed at runtime (see #722898)

=== debian/tests/control ===
Test-Command: cp "/usr/share/doc/nsis/Examples/Modern UI/MultiLanguage.nsi" . && makensis MultiLanguage.nsi
Depends: nsis, nsis-doc
Tests-Directory: tests

## nsis 3.08

=== SConstruct ===
--- 
+++ 
@@ -57,7 +57,8 @@
 doctypes = [
 	'chm',
 	'html',
-	'htmlsingle'
+	'htmlsingle',
+	'web',
 ]
 
 ######################################################################
@@ -95,8 +96,8 @@
 if defenv.WhereIs('hhc', os.environ['PATH']):
 	default_doctype = 'chm'
 
-from time import strftime, gmtime
-cvs_version = strftime('%d-%b-%Y.cvs', gmtime())
+import time
+cvs_version = time.strftime('%d-%b-%Y.cvs', time.gmtime(int(os.environ.get('SOURCE_DATE_EPOCH', time.time()))))
 
 opts = Variables()
 
@@ -213,7 +214,7 @@
 	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_DATA', '"%s"' % defenv.subst('$PREFIX_DATA'))])
 	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_DOC', '"%s"' % defenv.subst('$PREFIX_DOC'))])
 
-if defenv.get('SOURCE_DATE_EPOCH','') is not '':
+if defenv.get('SOURCE_DATE_EPOCH','') != '':
 	defenv['ENV']['SOURCE_DATE_EPOCH'] = defenv['SOURCE_DATE_EPOCH'] = int(defenv['SOURCE_DATE_EPOCH'], 0) # Normalize and apply to ENV for child processes
 	defenv.Append(NSIS_CPPDEFINES = [('NSIS_SOURCE_DATE_EPOCH', '%s' % defenv['SOURCE_DATE_EPOCH'])]) # Display in /HDRINFO
 
@@ -299,5 +300,3 @@
 
 ######################################################################
 #######  Common Functions                                          ###
-######################################################################
-

=== debian/changelog ===
nsis (3.08-2) unstable; urgency=medium

  * autopkgtest: Verify generated NSIS installer executable
  * d/copyright: Merged contributors, updated years, added
    bzip2 and lzma SDK license

 -- Thomas Gaugler <thomas@dadie.net>  Sat, 04 Dec 2021 10:14:19 +0100

nsis (3.08-1) unstable; urgency=medium

  * New upstream version 3.08
  * Fix fprintf format security warnings for halibut
  * debian/watch: Upgrade to version 4

 -- Thomas Gaugler <thomas@dadie.net>  Mon, 01 Nov 2021 11:04:27 +0800

nsis (3.07-1) unstable; urgency=medium

  * New upstream version 3.07

  [ Thomas Gaugler ]
  * Drop obsolete patches for version '3.07'
  * Propagate CCACHE_DIR environment variable via debian/rules
  * Use common tool variables inside debian/rules
  * Upgrade to Standards-Version 4.6.0 without changes needed
  * Remove outdated claim of overhead size within debian/control

  [ Didier Raboud ]
  * Remove myself from Uploaders

 -- Thomas Gaugler <thomas@dadie.net>  Wed, 01 Sep 2021 15:26:05 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: nsis
 Maintainer: Thomas Gaugler <thomas@dadie.net>
-Uploaders: Didier Raboud <odyx@debian.org>
 Section: devel
 Priority: optional
 Build-Depends: docbook-xsl-ns,
@@ -13,7 +12,7 @@
                xsltproc,
                zlib1g-dev,
                debhelper-compat (= 13)
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/nsis
 Vcs-Git: https://salsa.debian.org/debian/nsis.git
@@ -38,8 +37,7 @@
  script language supports variables, functions, string manipulation,
  just like a normal programming language - but designed for the creation
  of installers. Even with all these features, NSIS is still the smallest
- installer system available. With the default options, it has an overhead
- of only 34 KB.
+ installer system available.
 
 Package: nsis-common
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 include /usr/share/dpkg/pkg-info.mk
+include /usr/share/dpkg/buildtools.mk
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
@@ -49,6 +50,11 @@
 SCONSHOSTFLAGS = APPEND_CCFLAGS="$(shell dpkg-buildflags --get CPPFLAGS) \
   $(shell dpkg-buildflags --get CFLAGS)" \
   APPEND_LINKFLAGS="$(shell dpkg-buildflags --get LDFLAGS)"
+
+# Propagate CCACHE_DIR environment variable
+ifneq (,$(CCACHE_DIR))
+	SCONSHOSTFLAGS += CC="CCACHE_DIR=\"$(CCACHE_DIR)\" $(CC)" CXX="CCACHE_DIR=\"$(CCACHE_DIR)\" $(CXX)"
+endif
 
 SCONSOPTS = $(SCONSFLAGS) VERSION=$(VERSION) VER_MAJOR=$(VER_MAJOR) \
   VER_MINOR=$(VER_MINOR) VER_REVISION=$(VER_REVISION) \
@@ -211,11 +217,3 @@
 		if [ -f "$${script_path}" ]; then \
 			PATH=$(TESTDIR)$(PREFIX)/bin:$(PATH) \
 			NSISDIR=$(TESTDIR)$(DATADIR) \
-			NSISCONFDIR=$(TESTDIR)$(SYSCONF) \
-			"$(TESTDIR)$(PREFIX)/bin/makensis" \
-			"$${script_path}" \
-			-X"OutFile \"$(TESTDIR)/$${script%.nsi}.exe\"" \
-			|| exit 1; \
-		fi;; \
-		esac; \
-	done;

=== debian/tests/control ===
Test-Command: cp "/usr/share/doc/nsis/Examples/Modern UI/MultiLanguage.nsi" . && makensis MultiLanguage.nsi && 7z t -tNsis MultiLanguage.exe
Depends: nsis, nsis-doc, p7zip-full
Tests-Directory: tests

## nsis 3.09

=== debian/changelog ===
nsis (3.09-4ubuntu1) noble; urgency=medium

  * d/rules: strip off ubuntuX, buildX from package version before feeding it
    to scons as VERSION.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 11 Apr 2024 14:22:37 +1200

nsis (3.09-4build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:02:28 +1100

nsis (3.09-4) unstable; urgency=medium

  * Use -rcfile instead of -style command line option for html2text
    (Closes: #1064741)

 -- Thomas Gaugler <thomas@dadie.net>  Sat, 02 Mar 2024 09:11:24 +0100

nsis (3.09-3) unstable; urgency=medium

  * Use common options for nsis-doc installation
  * Added Breaks+Replaces fields to facilitate move of plugin example
    (Closes: #1060310)
  * Remove the disable reloc flag that is set by SCons
  * Exclude Debian revison suffix from VER_REVISION

 -- Thomas Gaugler <thomas@dadie.net>  Sun, 28 Jan 2024 11:58:35 +0100

nsis (3.09-2) unstable; urgency=medium

  * Bump Standards-Version to 4.6.2 (no changes needed)
  * Remove outdated debian/NEWS file
  * Eliminate leading comma in SKIPUTILS parameter
  * d/rules: Remove extraneous spaces
  * Use INSTDIR variable for common install path
  * Move plugin example from nsis-doc to nsis-pluginapi

 -- Thomas Gaugler <thomas@dadie.net>  Mon, 08 Jan 2024 11:14:55 +0100

nsis (3.09-1) unstable; urgency=medium

  * New upstream version 3.09. Fixes CVE-2023-37378. Closes: #1040880
  * Drop obsolete halibut patch for version '3.09'

 -- Thomas Gaugler <thomas@dadie.net>  Thu, 20 Jul 2023 09:58:41 +0200

nsis (3.08-3) unstable; urgency=medium

  [ Thomas Gaugler ]
  * Disable relocations for PE/COFF binary files
    - NSIS does not handle relocations.
    - See https://sourceforge.net/p/nsis/bugs/1283/ for more details
  * Fixes lintian:
    - no-code-sections falsely reported on PE/COFF libraries, #1005326
    - Overwrite very-long-line-length-in-source-file tag for ini,
      but (input format for generating documentiation) and HTML files
    - Overwrite source-is-missing tag because the HTML files are the
      original source files
    - Correct mismatched and unused overrides
  * Update standards version to 4.6.1

  [ Janitor ]
  * Remove unnecessary dpkg-dev constraint

 -- Thomas Gaugler <thomas@dadie.net>  Mon, 15 Aug 2022 07:58:35 +0200

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,18 @@
 Source: nsis
-Maintainer: Thomas Gaugler <thomas@dadie.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Thomas Gaugler <thomas@dadie.net>
 Section: devel
 Priority: optional
 Build-Depends: docbook-xsl-ns,
                docbook5-xml,
-               dpkg-dev (>= 1.17.0),
-               html2text,
+               html2text (>= 2.0.0),
                libcppunit-dev,
                mingw-w64,
                scons,
                xsltproc,
                zlib1g-dev,
                debhelper-compat (= 13)
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/nsis
 Vcs-Git: https://salsa.debian.org/debian/nsis.git
@@ -54,6 +54,9 @@
 Multi-Arch: foreign
 Depends: ${misc:Depends}
 Recommends: mingw-w64
+Replaces: nsis-doc (<< 3.09-2)
+Breaks: nsis-doc (<< 3.09-2)
+Suggests: nsis-doc (>= 3.09-2)
 Enhances: nsis (>= ${source:Version})
 Description: Nullsoft Scriptable Install System plugin API
  NSIS is a tool for creating quick and user friendly installers for

=== debian/rules ===
--- 
+++ 
@@ -11,13 +11,15 @@
 # Enable hardening
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
-VERSION=$(DEB_VERSION)
+VERSION=$(shell echo $(DEB_VERSION) | sed -Ee s/\(build\|ubuntu\)[0-9]+//)
+
 PREFIX=/usr
 DATADIR=$(PREFIX)/share/nsis
 DOCDIR=$(PREFIX)/share/doc/nsis
 SYSCONF=/etc
 BUILDDIR=build
 UNICODE=yes
+INSTDIR=$(CURDIR)/debian
 TESTDIR=$(CURDIR)/$(BUILDDIR)/test
 
 # Decomposition of version string
@@ -27,7 +29,7 @@
 VERSION_DECOMPOSED=$(call SPLIT,$(VERSION),. - + ~)
 VER_MAJOR=$(firstword $(VERSION_DECOMPOSED))
 VER_MINOR=$(word 2,$(VERSION_DECOMPOSED))
-VER_REVISION=$(word 3,$(VERSION_DECOMPOSED))
+VER_REVISION=$(firstword $(subst +, ,$(word 3,$(VERSION_DECOMPOSED))))
 
 # Variables for Win32/Win64 cross compiler
 XGCC_W32_X86 = i686-w64-mingw32-gcc
@@ -96,7 +98,7 @@
 IGNORE_UTILS_NSIS   := $(subst $(COMMA)VPatch/Source/GenPat,,$(UTILS_ALL))
 
 # Build the win32 user interfaces (UIs) and RegTool
-IGNORE_UTILS_COMMON := $(subst Library/RegTool,,$(UTILS_ALL))
+IGNORE_UTILS_COMMON := $(subst Library/RegTool$(COMMA),,$(UTILS_ALL))
 IGNORE_UTILS_COMMON := $(subst $(COMMA)UIs,,$(IGNORE_UTILS_COMMON))
 
 SCONSOPTS_HOST   := $(SCONSHOSTFLAGS) $(SCONSOPTS) \
@@ -112,8 +114,9 @@
 INSTALL_nsis-pluginapi = install-pluginapi
 INSTALL_FLAGS_nsis-pluginapi = $(SCONSOPTS_COMMON)
 INSTALL_nsis-doc = install-examples install-doc install-docs
-INSTALL_FLAGS_nsis-doc = $(SCONSHOSTFLAGS) $(SCONSOPTS) \
-  SKIPUTILS=$(IGNORE_UTILS_COMMON) SKIPDOC=COPYING
+INSTALL_FLAGS_nsis-doc = $(SCONSOPTS_COMMON) \
+  SKIPPLUGINS=ExDLL SKIPSTUBS=all SKIPUTILS=$(IGNORE_UTILS_COMMON) \
+  SKIPDOC=COPYING
 
 # Exclude test scripts which are not appropriate for POSIX platforms.
 IGNORE_TESTS = gfx.nsi|install-per-user.nsi|install-shared.nsi|makensis.nsi
@@ -121,8 +124,29 @@
 # Path to .nsi scripts
 SCRIPTS_PATH = $(DOCDIR)/Examples
 
+# Add contents to the given Debian package by taking
+# INSTALL_FLAGS_<package> and INSTALL_<package> variables into account.
+# $(1) package name, for example nsis-common
+# $(2) additional flags for scons
 define DO_SCONS_INSTALL
-	scons $(INSTALL_FLAGS_$(1)) $(2) PREFIX_DEST="$(CURDIR)/debian/$(1)" $(INSTALL_$(1)) || exit 1;
+	scons $(INSTALL_FLAGS_$(1)) $(2) PREFIX_DEST="$(INSTDIR)/$(1)" $(INSTALL_$(1)) || exit 1;
+endef
+
+# Add contents to the given Debian package via the path specfic target
+# $(1) package name, for example nsis-common
+# $(2) path specfic scons target
+define DO_SCONS_INSTALL_EXTRA
+	scons $(INSTALL_FLAGS_$(1)) PREFIX_DEST="$(INSTDIR)/$(1)" "$(INSTDIR)/$(1)$(2)" || exit 1;
+endef
+
+# Convert html to text using the pretty.style configuration
+# $(1) html formatted input file
+# $(2) If omitted then the resulting text is written to standard output
+#      otherwise to the provided output file
+define HTML2TEXT_PRETTY
+	html2text -nobs \
+		-rcfile /usr/share/doc/html2text/examples/pretty.style \
+		$(if $(2),-o $(2) ,)$(1)
 endef
 
 # Substitute reference to License text file in Modern UI examples
@@ -173,7 +197,7 @@
 override_dh_auto_build-indep: $(BUILDDIR)/NEWS
 	# nsis-common must be built on little-endian
 	[ "$(shell dpkg-architecture -qDEB_BUILD_ARCH_ENDIAN)" = "little" ]
-	
+
 	scons $(SCONSOPTS_HOST) makensis
 ifdef XGCC_W32_X86_PATH
 	scons $(SCONSOPTS_COMMON) $(SCONSOPTS_X86) stubs plugins utils
@@ -181,12 +205,12 @@
 ifdef XGCC_W32_AMD64_PATH
 	scons $(SCONSOPTS_COMMON) $(SCONSOPTS_AMD64) stubs plugins utils
 endif
-	html2text -style pretty -nobs -o "$(BUILDDIR)/README.Modern UI" "Contrib/Modern UI/Readme.html"
-	html2text -style pretty -nobs -o "$(BUILDDIR)/README.Modern UI 2" "Contrib/Modern UI 2/Readme.html"
-	html2text -style pretty -nobs -o $(BUILDDIR)/README.VPatch Contrib/VPatch/Readme.html
-	html2text -style pretty -nobs -o $(BUILDDIR)/README.InstallOptions Contrib/InstallOptions/Readme.html
-	html2text -style pretty -nobs -o $(BUILDDIR)/README.MultiUser Contrib/MultiUser/Readme.html
-	html2text -style pretty -nobs -o $(BUILDDIR)/README.nsDialogs Contrib/nsDialogs/Readme.html
+	$(call HTML2TEXT_PRETTY,"Contrib/Modern UI/Readme.html","$(BUILDDIR)/README.Modern UI")
+	$(call HTML2TEXT_PRETTY,"Contrib/Modern UI 2/Readme.html","$(BUILDDIR)/README.Modern UI 2")
+	$(call HTML2TEXT_PRETTY,Contrib/VPatch/Readme.html,$(BUILDDIR)/README.VPatch)
+	$(call HTML2TEXT_PRETTY,Contrib/InstallOptions/Readme.html,$(BUILDDIR)/README.InstallOptions)
+	$(call HTML2TEXT_PRETTY,Contrib/MultiUser/Readme.html,$(BUILDDIR)/README.MultiUser)
+	$(call HTML2TEXT_PRETTY,Contrib/nsDialogs/Readme.html,$(BUILDDIR)/README.nsDialogs)
 
 override_dh_auto_test-arch:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
@@ -196,24 +220,3 @@
 override_dh_auto_test-indep:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	test -x "$(BUILDDIR)/$(BUILDTYPE)/makensis/makensis" && \
-	scons $(INSTALL_FLAGS_nsis) PREFIX_DEST="$(TESTDIR)"\
-		install-compiler install-conf && \
-	scons $(INSTALL_FLAGS_nsis-doc) PREFIX_DEST="$(TESTDIR)"\
-		install-examples && \
-	scons $(INSTALL_FLAGS_nsis-common) $(SCONSOPTS_X86) PREFIX_DEST="$(TESTDIR)" \
-		$(INSTALL_nsis-common) && \
-	scons $(INSTALL_FLAGS_nsis-common) $(SCONSOPTS_AMD64) PREFIX_DEST="$(TESTDIR)" \
-		$(INSTALL_nsis-common) && \
-	$(call SANITIZE_MODERN_UI,$(TESTDIR)$(DOCDIR)/Examples/Modern UI) && \
-	for script_path in $(TESTDIR)$(SCRIPTS_PATH)/*.nsi \
-		$(TESTDIR)$(SCRIPTS_PATH)/*/*.nsi; do \
-		script=$${script_path#$(TESTDIR)$(SCRIPTS_PATH)/}; \
-		if [ "$${script%/*}" != "$${script}" ]; then \
-			mkdir -p "$(TESTDIR)/$${script%/*}"; \
-		fi; \
-		case $${script} in \
-		$(IGNORE_TESTS)) ;; \
-		*) \
-		if [ -f "$${script_path}" ]; then \
-			PATH=$(TESTDIR)$(PREFIX)/bin:$(PATH) \
-			NSISDIR=$(TESTDIR)$(DATADIR) \

=== debian/watch ===
version=4
https://sf.net/nsis/nsis-([\d.]*)-src.tar.bz2 debian uupdate
